/* common.h: header file for common.c; definition of common data types.
 */
#ifndef _COMMON_H
#define _COMMON_H

#include "llist.h"
#include "gene.h"
#include "arg.h"
/* Function prototypes; a brief explanation of each function should be
 * provided prior to its implementation in common.c.
 */
#ifdef ENABLE_VERBOSE
int verbose();
void set_verbose(int v);
#endif

#ifdef HAPLOTYPE_BLOCKS
typedef struct _SuperColumn {
  int left;
  int right;
} SuperColumn;

extern LList *representativeness;
extern LListCounter *representativeness_counter;
extern int **haploblocks;
void explode_local(int **local, LList *r, int n);
#endif
extern LList *eventlist;
#ifdef DEBUG
extern HashTable *ancestral_state_trace;
#endif

void *xmalloc(int n);
void *xcalloc(int m, int n);
void *xrealloc(void *oldadr, int n);
#define XRAND_MAX RAND_MAX
void initialise_xrandom();
long int xrandom();
char *i2a(int n);
void pretty_print(FILE *fp, char *s, int l, int i);
void print_option(FILE *fp, char *option, char *description, int l, int i);

#endif
